diff -ur sourceold/scripts/jmgUtility.h source/scripts/jmgUtility.h
--- sourceold/scripts/jmgUtility.h	2019-02-15 09:37:36.770000000 +1000
+++ source/scripts/jmgUtility.h	2019-06-22 07:43:44.247400000 +1000
@@ -172,6 +172,7 @@
   void Custom(GameObject *obj,int message,int param,GameObject *sender);
   void Killed(GameObject *obj,GameObject *killer);
   void Destroyed(GameObject *obj);
+  void Detach(GameObject *obj);
 };
 
 /*!
@@ -577,7 +578,7 @@
 	}
 	static char *Rp2Encrypt(const char *String,int EncryptionFactor,int Start)
 	{
-		static char FinalString[2000];
+		static char FinalString[65536];
 		sprintf(FinalString," ");
 		int loops = strlen(String),x = 0;
 		int CurrentAdd = Start;
@@ -602,7 +603,57 @@
 	}
 	static char *Rp2Encrypt2(const char *String,int EncryptionFactor,int Start)
 	{
-		static char FinalString[2000];
+		static char FinalString[65536];
+		sprintf(FinalString," ");
+		int loops = strlen(String),x = 0;
+		int CurrentAdd = Start;
+		while (x < loops)
+		{
+			if (String[x] > 31 && String[x] < 127)
+			{
+				int Temp = (String[x]+CurrentAdd);
+				while (Temp > 126)
+					Temp -= 95;
+				FinalString[x] = (char)Temp;
+			}
+			else
+				FinalString[x] = String[x];
+			x++;
+			CurrentAdd++;
+			if (CurrentAdd > EncryptionFactor)
+				CurrentAdd = 1;
+			FinalString[x] = '\0';
+		}
+		return FinalString;
+	}
+	static char *Rp2Encrypt3(const char *String,int EncryptionFactor,int Start)
+	{
+		static char FinalString[65536];
+		sprintf(FinalString," ");
+		int loops = strlen(String),x = 0;
+		int CurrentAdd = Start;
+		while (x < loops)
+		{
+			if (String[x] > 31 && String[x] < 127)
+			{
+				int Temp = (String[x]+CurrentAdd);
+				while (Temp > 126)
+					Temp -= 95;
+				FinalString[x] = (char)Temp;
+			}
+			else
+				FinalString[x] = String[x];
+			x++;
+			CurrentAdd++;
+			if (CurrentAdd > EncryptionFactor)
+				CurrentAdd = 1;
+			FinalString[x] = '\0';
+		}
+		return FinalString;
+	}
+	static char *Rp2Encrypt4(const char *String,int EncryptionFactor,int Start)
+	{
+		static char FinalString[65536];
 		sprintf(FinalString," ");
 		int loops = strlen(String),x = 0;
 		int CurrentAdd = Start;
@@ -627,7 +678,7 @@
 	}
 	static char *Rp2Decrypt(const char *String,int EncryptionFactor,int Start)
 	{
-		static char FinalString[2000];
+		static char FinalString[65536];
 		int loops = strlen(String),x = 0;
 		int CurrentAdd = Start;
 		while (x < loops)
@@ -1009,6 +1060,19 @@
 			current = current->next;
 		}
 	}
+	void Remove_Radar_Blip(int objectiveId)
+	{
+		ObjectiveNode *current = objectiveNodeList;
+		while (current)
+		{
+			if (current->id == objectiveId)
+			{
+				Destroy_Radar_Marker(Commands->Find_Object(current->radarMarkerId));
+				return;
+			}
+			current = current->next;
+		}
+	}
 	void Set_Radar_Blip(int objectiveId,Vector3 blipPosition,const char *modelOverride = NULL)
 	{
 		ObjectiveNode *current = objectiveNodeList;
@@ -1401,6 +1465,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	JMG_Utility_Sync_System_Controller();
 };
@@ -1426,6 +1491,7 @@
 * \EnableOrDisableCustom - Message used to enable the spawner, the parameter sent with it tell whether to enable or disable (1 for enable, 0 for disable, -1 disables and kills the spawned object, -2 disables and destroys the spawned object)
 * \SpawnLimit - How many objects can this script spawn
 * \DelayOnStartup - Day to spawn the first object when enabled
+* \Attach_Scripts_Group_ID - Defines what scripts should be attached with JMG_Utility_Basic_Spawner_Attach_Script (-1 attachs all scripts on the spawn controller that can be attached)
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -1435,6 +1501,7 @@
 	int spawnedId;
 	bool enabled;
 	float respawnTime;
+	int attachScriptsGroupId;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -1723,6 +1790,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 	static char musicFileName[256];
 public:
 	static bool controllerPlaced;
@@ -2148,17 +2216,21 @@
 * \brief Makes an aircraft move between wander points, it'll strafe at the target while it has one
 * \WanderingAIGroupID - Group of points to wander between
 * \FlightHeight - How high it should stay above the points
-* \FireRange - Max range that it can use it's guns
+* \FireRange - Max range that it can use it's guns, if less than 0 it uses the current weapon held's max range
 * \StealthModeOverride - 0 = normal stealth detection, 1 = sees everything, -1 = can't see any stealthed enemies
+* \NewPointDelay - Useful for aircraft with slow acceleration so that it doesn't keep trying to grab new points
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_AI_Guardian_Aircraft : public ScriptImpClass {
+	float fireRange;
 	Vector3 dpPosition;
 	int EnemyID;
 	int EnemyTimeOutTime;
 	Vector3 LastPos;
 	int stealthModeOverride;
+	int newPointDelay;
+	int remainingDelay;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Enemy_Seen(GameObject *obj,GameObject *seen);
@@ -2628,11 +2700,14 @@
 * \Script - Name of the script to attach
 * \Params - The parameters to use for the script
 * \Delim - The character to use in place of a ',' swapped at script creation
+* \Scripts_Group_ID - Defines what attach group this is in, if -1 it will attach to all the spawned objects spawned from this object.
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_Basic_Spawner_Attach_Script : public ScriptImpClass {
+	int scriptsGroupId;
 	char *params;
+	char script[128];
 	void Created(GameObject *obj);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
 };
@@ -2798,6 +2873,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	static bool controllerPlaced;
 };
@@ -3000,13 +3076,14 @@
 * \brief Makes a unit move between wander points, it'll strafe at the target while it has one, clone of JMG_Utility_AI_Guardian_Aircraft but with pathfind enabled
 * \WanderingAIGroupID - Group of points to wander between
 * \WanderSpeed - Speed the unit moves at 
-* \FireRange - Max range that it can use it's guns
+* \FireRange - Max range that it can use it's guns, if less than 0 it uses the current weapon held's max range
 * \CheckBlocked - Whether to check if the target spot is blocked before firing
 * \StealthModeOverride - 0 = normal stealth detection, 1 = sees everything, -1 = can't see any stealthed enemies
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_AI_Guardian_Infantry : public ScriptImpClass {
+	float fireRange;
 	Vector3 dpPosition;
 	int EnemyID;
 	int EnemyTimeOutTime;
@@ -3340,6 +3417,7 @@
 * \ChangeGroupIDCustom - Changes the wander point group id to a new one, uses the parameter on the custom sent in
 * \PlayerType - Playertype the zone triggers for
 * \RetryOnFailure - If this is true a script will be attached that will continue to try to teleport the player until successful (Warning: Turning this on hides error messages)
+* \AiOnly - Only trigger for AI
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -3349,6 +3427,7 @@
 	float safeTeleportDistance;
 	int wanderPointGroup;
 	int changeGroupIDCustom;
+	bool aiOnly;
 	void Created(GameObject *obj);
 	void Entered(GameObject *obj,GameObject *enterer);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -4086,7 +4165,7 @@
 * \brief Makes a unit move between wander points, it'll strafe at the target while it has one, clone of JMG_Utility_AI_Guardian_Aircraft but with pathfind enabled and allows you to turn off the engine on arrival, also well throw itself into reverse if it gets stuck
 * \WanderingAIGroupID - Group of points to wander between
 * \WanderSpeed - Speed the unit moves at 
-* \FireRange - Max range that it can use it's guns
+* \FireRange - Max range that it can use it's guns, if less than 0 it uses the current weapon held's max range
 * \CheckBlocked - Whether to check if the target spot is blocked before firing
 * \AimAtFeet - Should the vehicle aim at the feet of infantry
 * \TurnOffEngineOnArrival - Should the vehicle turn off its engine when it gets to its points (useful for wheeled vehicles that roll away)
@@ -4095,6 +4174,7 @@
 * \ingroup JmgUtility
 */
 class JMG_Utility_AI_Guardian_Vehicle : public ScriptImpClass {
+	float fireRange;
 	bool aimAtFeet;
 	Vector3 dpPosition;
 	int EnemyID;
@@ -4147,11 +4227,15 @@
 * \ReminderCustom - custom to send every time a reminder message shows up, param is the remaining lives, no delay
 * \AddDeathsWhenNoPlayers - Increases the death count (by one) at the rate specified here when no players are in game, if 0 no increase
 * \NoPlayersAddDeathSaftyTime - This amount of time must pass before deaths will start to be added, if a player rejoins the time will reset
+* \RequiresADeathToStartNoPlayerAdd - If true a player must have died once before the death countdown can start
+* \AnnounceOnFirstDeath - Shows the death message the first time any player dies so they are aware of it
+* \OnlyTrackPlayerDeaths - Only track player deaths, not AI
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_Send_Custom_On_Deaths_Controller : public ScriptImpClass
 {
+	bool requiresADeathToStartNoPlayerAdd;
 	float addDeathsWhenNoPlayers;
 	int noPlayersAddDeathSaftyTime;
 	int currentNoPlayersAddDeathSaftyTime;
@@ -4159,6 +4243,7 @@
 	void Timer_Expired(GameObject *obj,int number);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 	static char *formatReminderString(const char *format,...);
 public:
 	static void ReportLogic(GameObject *obj);
@@ -4176,6 +4261,8 @@
 	static char remainingPlural[220];
 	static int reminderMessageOrder;
 	static bool controllerPlaced;
+	static bool announceOnFirstDeath;
+	static bool onlyTrackPlayerDeaths;
 };
 
 /*!
@@ -4288,6 +4375,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 	static Vector3 controllerDefaultColor;
 	static float controllerDefaultOpacity;
 public:
@@ -4440,11 +4528,63 @@
 * \MinutePlural - This is the part of the message that displays minutes plural
 * \SecondSingular - This is the part of the message that displays second singular
 * \SecondPlural - This is the part of the message that displays seconds plural
+* \StartsPaused - If 0 the countdown will start paused
+* \PauseCustom - If recieved this pauses the countdown when the param is non-zero, unpauses when 0
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_HUD_Count_Down : public ScriptImpClass {
 public:
+	struct CountdownScreenCharacterNode
+	{
+		int id;
+		int charPos;
+		char currentChar;
+		char baseModelName[15];
+		struct CountdownScreenCharacterNode *next;
+		CountdownScreenCharacterNode(int id,int charPos,const char *baseModelName)
+		{
+			this->id = id;
+			this->charPos = charPos;
+			this->currentChar = '\0';
+			sprintf(this->baseModelName,"%s",baseModelName);
+			this->next = NULL;
+		}
+	};
+	static int highestCharPos;
+	static CountdownScreenCharacterNode *countdownScreenCharacterController;
+	static void AddVisualCountdownNode(int id,int charPos,const char *baseModelName)
+	{
+		if (charPos > 5)
+		{
+			Console_Input("msg AddVisualCountdownNode::ERROR charPos can be at most 5!");
+			return;
+		}
+		if (strlen(baseModelName) > 15)
+		{
+			Console_Input("msg AddVisualCountdownNode::ERROR baseModelName can be at most 15 characters (remember a number is added to the end)!");
+			return;
+		}
+		if (highestCharPos < charPos)
+			highestCharPos = charPos;
+		CountdownScreenCharacterNode *current = countdownScreenCharacterController;
+		if (!countdownScreenCharacterController)
+			countdownScreenCharacterController = new CountdownScreenCharacterNode(id,charPos,baseModelName);
+		while (current)
+		{
+			if (current->id == id)
+			{
+				Console_Input("msg AddVisualCountdownNode::ERROR: id has already been added once!");
+				return;
+			}
+			if (!current->next)
+			{
+				current->next = new CountdownScreenCharacterNode(id,charPos,baseModelName);
+				return;
+			}
+			current = current->next;
+		}
+	}
 	struct SendCustomOnSecondNode
 	{
 		bool hasTriggered;
@@ -4498,9 +4638,13 @@
 	char secondSingular[220];
 	char secondPlural[220];
 	int seconds;
+	int pauseCustom;
+	bool paused;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 	char *formatReminderString(const char *format,...);
 	
 	void NodeSendCustom(GameObject *obj,int second)
@@ -4520,6 +4664,7 @@
 	}
 	void CleanupSecondNodes()
 	{
+		controllerPlaced = false;
 		SendCustomOnSecondNode *temp = sendCustomOnSecondController,*die;
 		while (temp)
 		{
@@ -4528,6 +4673,38 @@
 			delete die;
 		}
 		sendCustomOnSecondController = NULL;
+		CountdownScreenCharacterNode *temp2 = countdownScreenCharacterController,*die2;
+		while (temp2)
+		{
+			GameObject *kill = Commands->Find_Object(temp2->id);
+			if (kill)
+				Commands->Destroy_Object(kill);
+			die2 = temp2;
+			temp2 = temp2->next;
+			delete die2;
+		}
+		countdownScreenCharacterController = NULL;
+		highestCharPos = -1;
+	}
+	void UpdateCountdownHudNodes()
+	{
+		if (highestCharPos <= 0)
+			return;
+		char hhmmss[6];
+		sprintf(hhmmss,"%02d%02d%02d",seconds/3600,(seconds%3600)/60,(seconds%3600)%60);
+		for (int x = 0;x <= highestCharPos;x++)
+			for (CountdownScreenCharacterNode *current = countdownScreenCharacterController;current;current = current->next)
+			{
+				if (current->charPos == x && current->currentChar != hhmmss[5-x])
+				{
+					GameObject *object = Commands->Find_Object(current->id);
+					if (!object)
+						continue;
+					char model[16];
+					sprintf(model,"%s%c",current->baseModelName,hhmmss[5-x]);
+					Commands->Set_Model(object,model);
+				}
+			}
 	}
 };
 /*!
@@ -4669,6 +4846,7 @@
 class JMG_Utility_AI_Follow_Player_On_Poke_Controller : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	static bool controllerPlaced;
 	static int maxFollowers;
@@ -5207,7 +5385,7 @@
 * \brief Makes a unit move between wander points, it'll strafe at the target while it has one, clone of JMG_Utility_AI_Guardian_Aircraft but with pathfind enabled
 * \WanderingAIGroupID - Group of points to wander between
 * \WanderSpeed - Speed the unit moves at 
-* \FireRange - Max range that it can use it's guns
+* \FireRange - Max range that it can use it's guns, if less than 0 it uses the current weapon held's max range
 * \CheckBlocked - Whether to check if the target spot is blocked before firing
 * \ArriveDistance - Distance to get close to
 * \FlightHeight - How high should the aircraft fly (use 0 if not an aircraft)
@@ -5218,6 +5396,7 @@
 * \ingroup JmgUtility
 */
 class JMG_Utility_AI_Guardian_Generic : public ScriptImpClass {
+	float fireRange;
 	float flightHeight;
 	float arriveDistance;
 	float arriveDistanceSq;
@@ -5488,7 +5667,7 @@
 };
 
 /*!
-* \brief Sends a custom when an object is destroyed
+* \brief Sends a custom when the attached powerup is collected
 * \ID - Id of the object to send the custom to, 0 sends to itself, -1 sends it to the person who picked it up
 * \Message - Custom to send
 * \Param - parameter to send with the custom
@@ -5671,10 +5850,12 @@
 * \DamageAmount - How much damage to apply
 * \Warhead - What warhead to use
 * \DamagerId - ID of what is applying the damage, 0 = nothing, -1 = enter, -2 = zone
+* \Team - 2 everyone, 0 Nod, 1 GDI
 * \author jgray
 * \ingroup JmgUtility
 */
 class JMG_Utility_Apply_Damage_While_In_Zone : public ScriptImpClass {
+	int team;
 	char params[512];
 	void Created(GameObject *obj);
 	void Entered(GameObject *obj,GameObject *enterer);
@@ -5861,6 +6042,7 @@
 class JMG_Utility_Spawn_With_Last_Selected_Gun_Control : public ScriptImpClass {
 	void Created(GameObject *obj);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	static bool controllerPlaced;
 	static char playerWeapons[128][256];
@@ -6037,6 +6219,7 @@
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	static bool controllerPlaced;
 	static bool isAFK[128];
@@ -6115,6 +6298,9 @@
 * \ if the value is above 0 the objects will only be checked against other objects with the same value.
 * \Starts_Disabled - If set to 1 the script won't be able to spawn objects until an Enable_Disable_Custom with a param of 1 is received
 * \Enable_Disable_Custom - Custom used to enable or disable the spawners, if the param is 0 it will be disabled, 1 will attempt to spawn the max, anything else just enables the spawn code
+* \Raycast_Direction_Override[Bottom|Top|Unused] - Specify the Z range in which the ray is cast (Default 0|0 lets the game script decide)
+* \Attach_Scripts_Group_ID - Defines what scripts should be attached with JMG_Utility_Basic_Spawner_Attach_Script (-1 attachs all scripts on the spawn controller that can be attached)
+* \PlayersAddToSpawnAtATime - Each player in game adds to the max number of things this can spawn at a time
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -6161,6 +6347,9 @@
 	float faceDirection;
 	int enableDisableCustom;
 	int initialSpawn;
+	Vector3 raycastRange;
+	int attachScriptsGroupId;
+	float playersAddToSpawnAtATime;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Custom(GameObject *obj,int message,int param,GameObject *sender);
@@ -6168,6 +6357,7 @@
 	bool CheckIfObjectIsNearAnotherObject(Vector3 pos);
 	void SetFacing(GameObject *obj,float facing);
 	void Initial_Spawn(GameObject *obj);
+	int GetPlayerLimitModifier();
 };
 
 /*!
@@ -6211,11 +6401,15 @@
 * \Enemy_Preset_ID - Preset ID required to be seen to remove the script, if 0 any enemy will trigger the script
 * \ID - Id of the object to send the custom to, 0 sends to itself, -1 sends to the seen object
 * \Visible_Message - Custom to send when there is a target that is visible
-* \Visible_Param - Param to send when there is a target that is visible
+* \Visible_Param - Param to send when there is a target that is visible, if -1 it's the id of the seen object
 * \Not_Visible_Message - Custom sent when no preset is visible anymore
-* \Not_Visible_Param - Param sent when no preset is visible anymore
-* \Max_Lost_Sight_Time - This is the max amount of time an enmey can go without being seen before being lost, 
-* \  game scans at least once a second so I reccomend at least 2.5 seconds if not longer
+* \Not_Visible_Param - Param sent when no preset is visible anymore, if -1 it's the id of the seen object
+* \Max_Lost_Sight_Time - This is the max amount of time an enemy can go without being seen before being lost
+* \  game scans at least once a second so I recommend at least 2.5 seconds if not longer
+* \RepeatSendSeenCustom - If set to true this custom will continue to be fired 10 times a second
+* \AttackPriority[Car|Tank|Bike] - Higher the value the more the object is prioritized, 0 can't be targeted
+* \AttackPriority[Flying|Turret|Boat] - Higher the value the more the object is prioritized, 0 can't be targeted
+* \AttackPriority[Submarine|Infantry|Unused - Higher the value the more the object is prioritized, 0 can't be targeted
 * \author jgray
 * \ingroup JmgUtility
 */
@@ -6229,9 +6423,15 @@
 	int visibleParam;
 	int notVisibleParam;
 	int maxNotSeenTime;
+	bool repeatSendSeenCustom;
+	Vector3 carTankBike;
+	Vector3 flyingTurretBoat;
+	Vector3 submarineInfantryUnused;
 	void Created(GameObject *obj);
 	void Timer_Expired(GameObject *obj,int number);
 	void Enemy_Seen(GameObject *obj,GameObject *seen);
+	float GetPriority(GameObject *seen);
+	void SendCustom(GameObject *obj,int custom,int param);
 };
 
 /*!
@@ -6277,6 +6477,7 @@
 */
 class JMG_Utility_Basic_Spawner_In_Radius_Controller: public ScriptImpClass {
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 };
 
 /*!
@@ -6716,6 +6917,7 @@
 			JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[x] = JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionSystem();
 	}
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 };
 
 /*!
@@ -7018,6 +7220,7 @@
 	}
 private:
 	void Destroyed(GameObject *obj);
+	void Detach(GameObject *obj);
 public:
 	static bool exists;
 	JMG_Utility_Swimming_Infantry_Advanced_Controller()
